﻿//CustomClass Template - Created by CodenameGamma
//Replace Layout with the CC name, 
//and WoWClass.Mage with the Class your Designing for.
//Created July, 3rd 2010
//For use with Honorbuddy
using System;
using System.Collections.Generic;
using System.Diagnostics;
using System.Linq;
using System.Threading;
using System.IO;
using System.Drawing;
using Styx;
using Styx.Combat.CombatRoutine;
using Styx.Helpers;
using Styx.Logic;
using Styx.Logic.Combat;
using Styx.Logic.Pathing;
using Styx.WoWInternals;
using Styx.WoWInternals.WoWObjects;
using TreeSharp;

namespace TitanArms
{
    class Classname : CombatRoutine
    {
        public override sealed string Name { get { return "Titan Arms v3.0A"; } }

        public override WoWClass Class { get { return WoWClass.Warrior; } }

        private static LocalPlayer Me { get { return ObjectManager.Me; } }

        #region Log
        private void slog(string format, params object[] args) //use for slogging
        {
            Logging.Write(format, args);
        }
        #endregion

        #region Initialize
        public override void Initialize()
        {
            Logging.Write(Color.White, "___________________________________________________");
            Logging.Write(Color.Crimson, "-------- Titan Arms v3.0A CC by Shaddar --------");
            Logging.Write(Color.Crimson, "-----  Remember to comment on the forum! --");
            Logging.Write(Color.Crimson, "-------- /like and +rep if you like this CC! ------");
            Logging.Write(Color.White, "___________________________________________________");
            Logging.Write(Color.White, "_I would like to thank these for helping me out!_");
            Logging.Write(Color.Crimson, "__________xLegendx, Stree and Daorigin__________");
            Logging.Write(Color.Crimson, "___CodenameG, Nomnomnom, Mahe4, Jasf10__");
            Logging.Write(Color.White, "__________________and Macphee!____________________");
        }
        #endregion

        #region Settings

        public override bool WantButton
        {
            get
            {
                return true;
            }
        }

        public override void OnButtonPress()
        {

            TitanArms.TitanForm1 f1 = new TitanArms.TitanForm1();
            f1.ShowDialog();
        }
        #endregion

        #region Executioneer
        private bool NeedStackExecutioner()
        {
            using (new FrameLock())
            {
                return !Me.ActiveAuras.ContainsKey("Executioner") || Me.ActiveAuras["Executioner"].StackCount < 5 || Me.ActiveAuras["Executioner"].TimeLeft.Seconds <= 3;
            }
        }
        #endregion

        #region Dragon Soul
        public bool Ultra()
        {
            using (new FrameLock())
            {
                if (TitanSettings.Instance.DSNOR || TitanSettings.Instance.DSHC || TitanSettings.Instance.DSLFR)
                {
                    foreach (WoWUnit u in ObjectManager.GetObjectsOfType<WoWUnit>(true, true))
                    {
                        if (u.IsAlive
                            && u.Guid != Me.Guid
                            && u.IsHostile
                            && u.IsCasting
                            && u.CastingSpell.Name == "Hour of Twilight"
                            && u.CurrentCastTimeLeft.TotalMilliseconds <= 800)
                            return true;
                    }

                }

            }
            return false;
        }
        public bool UltraFL()
        {
            using (new FrameLock())
            {
                if (TitanSettings.Instance.DSNOR || TitanSettings.Instance.DSHC)
                {
                    foreach (WoWUnit u in ObjectManager.GetObjectsOfType<LocalPlayer>(true, true))
                    {
                        if (u.Debuffs.ContainsKey("Fading Light")
                            && u.Debuffs["Fading Light"].IsActive
                            && u.Debuffs["Fading Light"].TimeLeft.TotalMilliseconds <= 1000)
                            return true;
                    }

                }

            }
            return false;
        }
        public bool DW()
        {
            using (new FrameLock())
            {
                if (TitanSettings.Instance.DSNOR || TitanSettings.Instance.DSHC || TitanSettings.Instance.DSLFR)
                {
                    foreach (WoWUnit u in ObjectManager.GetObjectsOfType<WoWUnit>(true, true))
                    {
                        if (u.IsAlive
                            && u.Guid != Me.Guid
                            && u.IsHostile
                            && (u.IsTargetingMyPartyMember || u.IsTargetingMyRaidMember || u.IsTargetingMeOrPet || u.IsTargetingAnyMinion)
                            && u.IsCasting
                            && u.CastingSpell.Name == "Shrapnel"
                            && u.CurrentCastTimeLeft.TotalMilliseconds <= 1000)
                            return true;
                    }

                }

            }
            return false;
        }
        #endregion

        #region Add Detection
        private int addCount()
        {
            int count = 0;
            foreach (WoWUnit u in ObjectManager.GetObjectsOfType<WoWUnit>(true, true))
            {
                if (u.IsAlive
                    && u.Guid != Me.Guid
                    && u.IsHostile
                    && !u.IsCritter
                    && (u.Location.Distance(Me.CurrentTarget.Location) <= 12 || u.Location.Distance2D(Me.CurrentTarget.Location) <= 12)
                    && (u.IsTargetingMyPartyMember || u.IsTargetingMyRaidMember || u.IsTargetingMeOrPet || u.IsTargetingAnyMinion)
                    && !u.IsFriendly)
                {
                    count++;
                }
            }
            return count;
        }
        private bool IsTargetBoss()
        {
            using (new FrameLock())
            {
                if (Me.CurrentTarget.CreatureRank == WoWUnitClassificationType.WorldBoss ||
                (Me.CurrentTarget.Level >= 85 && Me.CurrentTarget.Elite) && Me.CurrentTarget.MaxHealth > 3500000)
                    return true;

                else return false;
            }
        }
        #endregion

        #region CastSpell Method
        // Credit to Apoc for the below CastSpell code
        // Used for calling CastSpell in the Combat Rotation
        //Credit to Wulf!
        public bool CastSpell(string spellName)
        {
            using (new FrameLock())
            {
                if (SpellManager.CanCast(spellName))
                {
                    SpellManager.Cast(spellName);
                    // We managed to cast the spell, so return true, saying we were able to cast it.
                    return true;
                }
            }
            // Can't cast the spell right now, so return false.
            return false;
        }
        #endregion

        #region MyDebuffTime
        //Used for checking how the time left on "my" debuff
        private int MyDebuffTime(String spellName, WoWUnit unit)
        {
            using (new FrameLock())
            {
                if (unit.HasAura(spellName))
                {
                    var auras = unit.GetAllAuras();
                    foreach (var a in auras)
                    {
                        if (a.Name == spellName && a.CreatorGuid == Me.Guid)
                        {
                            return a.TimeLeft.Seconds;
                        }
                    }
                }
            }
            return 0;
        }
        #endregion

        #region DebuffTime
        //Used for checking debuff timers
        private int DebuffTime(String spellName, WoWUnit unit)
        {
            using (new FrameLock())
            {
                if (unit.HasAura(spellName))
                {
                    var auras = unit.GetAllAuras();
                    foreach (var b in auras)
                    {
                        if (b.Name == spellName)
                        {
                            return b.TimeLeft.Seconds;
                        }
                    }
                }
            }
            return 0;
        }
        #endregion

        #region IsMyAuraActive
        //Used for checking auras that has no time
        private bool IsMyAuraActive(WoWUnit Who, String What)
        {
            using (new FrameLock())
            {
                return Who.GetAllAuras().Where(p => p.CreatorGuid == Me.Guid && p.Name == What).FirstOrDefault() != null;
            }
        }
        #endregion

        #region CombatStart


        private void AutoAttack()
        {
            if (!Me.IsAutoAttacking && Me.CurrentTarget.Distance <= 7d)
            {
                Lua.DoString("StartAttack()");
            }
        }
        #endregion

        #region Combat

        public override void Combat()
        {
            if (Me.CurrentTarget != null && Me.CurrentTarget.IsAlive && !Me.Mounted)
            {

                ///////////////////////////////////////////////Stance 'n Shouts + random////////////////////////////////////////////////////////////////////////////////////////////////
                {
                    if (Ultra())
                    {
                        Lua.DoString("RunMacroText('/click ExtraActionButton1');");
                        {
                            Logging.Write(Color.Aqua, ">> Heroic Will! <<");
                        }
                    }
                }
                {
                    if (UltraFL())
                    {
                        Lua.DoString("RunMacroText('/click ExtraActionButton1');");
                        {
                            Logging.Write(Color.Aqua, ">> Heroic Will! <<");
                        }
                    }
                }
                {
                    if (DW())
                    {
                        Lua.DoString("RunMacroText('/click ExtraActionButton1');");
                        {
                            Logging.Write(Color.Aqua, ">> Enter the dream! <<");
                        }
                    }
                }
                {
                    if (Me.CurrentTarget.HealthPercent > 20)
                    {
                        Lua.DoString("RunMacroText('/cast [stance:3/3, nomodifier]Battle Stance');");
                    }
                }
                {
                    if (addCount() < TitanSettings.Instance.Mobs && Me.CurrentTarget.HealthPercent <= 20)
                    {
                        Lua.DoString("RunMacroText('/cast [stance:1/3, nomodifier]Berserker Stance');");
                    }
                }
                {
                    if (Me.Combat && Me.RagePercent < 30)
                    {
                        if (CastSpell("Battle Shout"))
                        {
                            Logging.Write(Color.Red, ">> Battle Shout <<");
                        }
                    }
                }
                /////////////////////////////////////////////Out of Range rotation here//////////////////////////////////////////////////////////////////////////////////////

                {
                    if (TitanSettings.Instance.CHRG && Me.CurrentTarget.Distance >= 12d && Me.CurrentTarget.Distance <= 30d)
                    {
                        if (CastSpell("Charge"))
                        {
                            Logging.Write(Color.Crimson, ">> Charge <<");
                        }
                    }
                }
                {
                    if (TitanSettings.Instance.HL && Me.CurrentTarget.Distance >= 12d && Me.CurrentTarget.Distance <= 40d && SpellManager.Spells["Charge"].CooldownTimeLeft.TotalSeconds < 10 && SpellManager.Spells["Charge"].CooldownTimeLeft.TotalSeconds > 1)
                    {
                        Lua.DoString("CastSpellByName('Heroic Leap');");
                        {
                            LegacySpellManager.ClickRemoteLocation(StyxWoW.Me.CurrentTarget.Location);
                        }
                    }
                }
                /////////////////////////////////////////////AoE Rotation here/////////////////////////////////////////////////////////////////////////////////////////////////

            }
            if (Me.CurrentTarget.Distance <= 10d && Me.CurrentTarget.IsAlive && !Me.Mounted && TitanSettings.Instance.AOE)
            {
                {
                    if (TitanSettings.Instance.BS && addCount() >= TitanSettings.Instance.Mobs && !Me.ActiveAuras.ContainsKey("Deadly Calm") && !Me.Auras.ContainsKey("Sweeping Strikes"))
                    {
                        if (CastSpell("Bladestorm"))
                        {
                            Logging.Write(Color.Aqua, ">> Bladestorm <<");
                        }
                    }
                }
                {
                    if (addCount() >= 2)
                    {
                        if (CastSpell("Sweeping Strikes"))
                        {
                            Logging.Write(Color.Aqua, ">> Sweeping Strikes <<");
                        }
                    }
                }
                {
                    if (addCount() >= TitanSettings.Instance.Mobs && !Me.ActiveAuras.ContainsKey("Sweeping Strikes"))
                    {
                        if (CastSpell("Cleave"))
                        {
                            Logging.Write(Color.Aqua, ">> Cleave <<");
                        }
                    }
                }
                /////////////////////////////////////////////Cooldowns are here////////////////////////////////////////////////////////////////////////////////////////////////

            }
            if (Me.CurrentTarget != null && Me.CurrentTarget.IsAlive && !Me.Mounted)
            {


                {
                    if (TitanSettings.Instance.RCKLS && Me.Auras.ContainsKey("Slaughter") && IsTargetBoss())
                        if (CastSpell("Recklessness"))
                            Logging.Write(Color.FloralWhite, ">> Recklessness <<");
                }
                {
                    if (Me.RagePercent < 20)
                        if (CastSpell("Berserker Rage"))
                            Logging.Write(Color.FloralWhite, ">> Berserker Rage <<");
                }
                {
                    if (Me.HasAura("Berserker Rage") && Me.HealthPercent < 30)
                        if (CastSpell("Enraged Regeneration"))
                            Logging.Write(Color.FloralWhite, ">> Enraged Regeneration <<");
                }
                {
                    if (TitanSettings.Instance.DC && MyDebuffTime("Rend", Me.CurrentTarget) > 1 && Me.CurrentTarget.Distance <= 7d && Me.CurrentRage < 50)
                        if (CastSpell("Deadly Calm"))
                            Logging.Write(Color.Crimson, ">> Deadly Calm <<");
                }
                {
                    if (TitanSettings.Instance.IR && Me.RagePercent > 70 || TitanSettings.Instance.IR && addCount() >= TitanSettings.Instance.Mobs && TitanSettings.Instance.AOE)
                        if (CastSpell("Inner Rage") )
                            Logging.Write(Color.Crimson, ">> Inner Rage <<");
                }
                {
                    if (TitanSettings.Instance.T1 && IsTargetBoss() && StyxWoW.Me.Inventory.Equipped.Trinket1 != null && StyxWoW.Me.Inventory.Equipped.Trinket1.Cooldown <= 0)
                        Lua.DoString("RunMacroText('/use 13');");
                }
                {
                    if (TitanSettings.Instance.T2 && IsTargetBoss() && StyxWoW.Me.Inventory.Equipped.Trinket2 != null && StyxWoW.Me.Inventory.Equipped.Trinket2.Cooldown <= 0)
                        Lua.DoString("RunMacroText('/use 14');");
                }
                {
                    if (IsTargetBoss())
                        Lua.DoString("RunMacroText('/use 10');");

                    //////////////////////////////////////////////////Racial Skills here/////////////////////////////////////////////////////////////////////////////////////////
                }
                {
                    if (IsTargetBoss() && Me.Race == WoWRace.Troll && IsTargetBoss())
                        Lua.DoString("RunMacroText('/Cast Berserking');");
                }
                {
                    if (IsTargetBoss() && Me.Race == WoWRace.Orc && IsTargetBoss())
                        Lua.DoString("RunMacroText('/Cast Blood Fury');");
                }

                //////////////////////////////////////////////Execute Phase here//////////////////////////////////////////////////////////////////////////////////////////////// 
            }
            if (Me.CurrentTarget != null && Me.CurrentTarget.IsAlive && !Me.Mounted && addCount() < TitanSettings.Instance.Mobs)
            {

                if (MyDebuffTime("Colossus Smash", Me.CurrentTarget) < 1)
                {
                    if (CastSpell("Colossus Smash"))
                    {
                        Logging.Write(Color.Aqua, ">> Colossus Smash <<");
                    }
                }
                {
                    if (Me.CurrentTarget.HealthPercent <= 20 && NeedStackExecutioner())
                        if (CastSpell("Execute"))
                            Logging.Write(Color.Red, ">> Execute! <<");
                }
                {
                    if (Me.CurrentTarget.HealthPercent <= 20 && !NeedStackExecutioner())
                        if (CastSpell("Mortal Strike"))
                            Logging.Write(Color.Red, ">> Mortal Strike! <<");
                }
                {
                    if (SpellManager.Spells["Mortal Strike"].CooldownTimeLeft.Milliseconds > 560 && Me.RagePercent >= 60 && Me.CurrentTarget.HealthPercent <= 20)
                        if (CastSpell("Execute"))
                            Logging.Write(Color.Red, ">> Execute! <<");
                }

                /////////////////////////////////////////////Single Target DPS here////////////////////////////////////////////////////////////////////////////////////////////

            }
            if (Me.CurrentTarget != null && Me.CurrentTarget.IsAlive && !Me.Mounted && addCount() < TitanSettings.Instance.Mobs)
            {
                if (Me.ActiveAuras.ContainsKey("Victorious"))
                {
                    if(CastSpell("Victory Rush"))
                    {
                        Logging.Write(Color.Aqua, ">> Victory Rush <<");
                    }
                }
                if (MyDebuffTime("Rend", Me.CurrentTarget) < 1)
                {
                    if (CastSpell("Rend"))
                    {
                        Logging.Write(Color.Aqua, ">> Rend <<");
                    }
                }
                if (!Me.ActiveAuras.ContainsKey("Taste for Blood") && SpellManager.Spells["Mortal Strike"].CooldownTimeLeft.Milliseconds > 560
                    && Me.CurrentTarget.HealthPercent > 20)
                {
                    if (CastSpell("Slam"))
                    {
                        Logging.Write(Color.Aqua, ">> Slam! <<");
                    }
                }
                if (Me.RagePercent > 65 && Me.CurrentTarget.HealthPercent > 20 || Me.ActiveAuras.ContainsKey("Inner Rage") && Me.RagePercent > 50 && Me.CurrentTarget.HealthPercent > 20)
                {
                    if (CastSpell("Heroic Strike"))
                    {
                        Logging.Write(Color.Aqua, ">> Heroic Strike <<");
                    }
                }
                if (Me.CurrentTarget.HealthPercent > 20)
                {
                    if (CastSpell("Mortal Strike"))
                    {
                        Logging.Write(Color.Aqua, ">> Mortal Strike <<");
                    }
                }
                if (Me.Auras.ContainsKey("Taste for Blood") && Me.CurrentTarget.HealthPercent > 20)
                {
                    if (CastSpell("Overpower"))
                    {
                        Logging.Write(Color.Aqua, ">> Overpower <<");
                    }
                }
                
                
                //////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
            }

        }

        #endregion

    }
}