﻿using System;
using System.Diagnostics;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;

using Styx;
using Styx.Combat.CombatRoutine;
using Styx.Helpers;
using Styx.Logic;
using Styx.Logic.Combat;
using Styx.Logic.Pathing;
using Styx.WoWInternals;
using Styx.WoWInternals.WoWObjects;

namespace TitanArms
{
    public partial class TitanForm1 : Form
    {
        public TitanForm1()
        {
            InitializeComponent();
        }

        private void TitanForm1_Load(object sender, EventArgs e)
        {
            TitanSettings.Instance.Load();

            Mobs.Value = new decimal(TitanSettings.Instance.Mobs);
            DC.Checked = TitanSettings.Instance.DC;
            RCKLS.Checked = TitanSettings.Instance.RCKLS;
            T1.Checked = TitanSettings.Instance.T1;
            T2.Checked = TitanSettings.Instance.T2;
            CHRG.Checked = TitanSettings.Instance.CHRG;
            HL.Checked = TitanSettings.Instance.HL;
            BS.Checked = TitanSettings.Instance.BS;
            SS.Checked = TitanSettings.Instance.SS;
            IR.Checked = TitanSettings.Instance.IR;
            LB.Checked = TitanSettings.Instance.LB;
            RS.Checked = TitanSettings.Instance.RS;
            AOE.Checked = TitanSettings.Instance.AOE;
            Party.Checked = TitanSettings.Instance.Party;
            DSHC.Checked = TitanSettings.Instance.DSHC;
            DSLFR.Checked = TitanSettings.Instance.DSLFR;
            DSNOR.Checked = TitanSettings.Instance.DSNOR;
        }
        private void linkLabel1_LinkClicked(object sender, LinkLabelLinkClickedEventArgs e)
        {
            System.Diagnostics.Process.Start("http://www.thebuddyforum.com/reputation.php?do=addreputation&p=422915");
            linkLabel1.LinkVisited = true;
        }
        private void linkLabel2_LinkClicked_1(object sender, LinkLabelLinkClickedEventArgs e)
        {
            System.Diagnostics.Process.Start("http://www.thebuddyforum.com/newreply.php?p=423850&noquote=1");
            linkLabel2.LinkVisited = true;
        }
        private void Mobs_ValueChanged_1(object sender, EventArgs e)
        {
            TitanSettings.Instance.Mobs = (int)Mobs.Value;
        }
        private void DC_CheckedChanged_1(object sender, EventArgs e)
        {
            if (DC.Checked == true)
            {
                TitanSettings.Instance.DC = true;
            }
            else
            {
                TitanSettings.Instance.DC = false;
            }
        }
        private void RCKLS_CheckedChanged_1(object sender, EventArgs e)
        {
            if (RCKLS.Checked == true)
            {
                TitanSettings.Instance.RCKLS = true;
            }
            else
            {
                TitanSettings.Instance.RCKLS = false;
            }
        }
        private void T1_CheckedChanged_1(object sender, EventArgs e)
        {
            if (T1.Checked == true)
            {
                TitanSettings.Instance.T1 = true;
            }
            else
            {
                TitanSettings.Instance.T1 = false;
            }
        }
        private void T2_CheckedChanged(object sender, EventArgs e)
        {
            if (T2.Checked == true)
            {
                TitanSettings.Instance.T2 = true;
            }
            else
            {
                TitanSettings.Instance.T2 = false;
            }
        }
        private void CHRG_CheckedChanged_1(object sender, EventArgs e)
        {
            if (CHRG.Checked == true)
            {
                TitanSettings.Instance.CHRG = true;
            }
            else
            {
                TitanSettings.Instance.CHRG = false;
            }
        }
        private void HL_CheckedChanged_1(object sender, EventArgs e)
        {
            if (HL.Checked == true)
            {
                TitanSettings.Instance.HL = true;
            }
            else
            {
                TitanSettings.Instance.HL = false;
            }
        }
        private void BS_CheckedChanged_1(object sender, EventArgs e)
        {
            if (BS.Checked == true)
            {
                TitanSettings.Instance.BS = true;
            }
            else
            {
                TitanSettings.Instance.BS = false;
            }
        }
        private void SS_CheckedChanged_1(object sender, EventArgs e)
        {
            if (SS.Checked == true)
            {
                TitanSettings.Instance.SS = true;
            }
            else
            {
                TitanSettings.Instance.SS = false;
            }
        }
        private void IR_CheckedChanged_1(object sender, EventArgs e)
        {
            if (IR.Checked == true)
            {
                TitanSettings.Instance.IR = true;
            }
            else
            {
                TitanSettings.Instance.IR = false;
            }
        }
        private void LB_CheckedChanged_1(object sender, EventArgs e)
        {
            if (LB.Checked == true)
            {
                TitanSettings.Instance.LB = true;
            }
            else
            {
                TitanSettings.Instance.LB = false;
            }
        }
        private void RS_CheckedChanged_1(object sender, EventArgs e)
        {
            if (RS.Checked == true)
            {
                TitanSettings.Instance.RS = true;
            }
            else
            {
                TitanSettings.Instance.RS = false;
            }
        }
        private void AOE_CheckedChanged_1(object sender, EventArgs e)
        {
            if (AOE.Checked == true)
            {
                TitanSettings.Instance.AOE = true;
            }
            else
            {
                TitanSettings.Instance.AOE = false;
            }
        }
        private void Party_CheckedChanged_1(object sender, EventArgs e)
        {
            if (Party.Checked == true)
            {
                TitanSettings.Instance.Party = true;
            }
            else
            {
                TitanSettings.Instance.Party = false;
            }
        }
        private void DSHC_CheckedChanged_1(object sender, EventArgs e)
        {
            if (DSHC.Checked == true)
            {
                TitanSettings.Instance.DSHC = true;
            }
            else
            {
                TitanSettings.Instance.DSHC = false;
            }
        }
        private void DSLFR_CheckedChanged_1(object sender, EventArgs e)
        {
            if (DSLFR.Checked == true)
            {
                TitanSettings.Instance.DSLFR = true;
            }
            else
            {
                TitanSettings.Instance.DSLFR = false;
            }
        }
        private void DSNOR_CheckedChanged_1(object sender, EventArgs e)
        {
            if (DSNOR.Checked == true)
            {
                TitanSettings.Instance.DSNOR = true;
            }
            else
            {
                TitanSettings.Instance.DSNOR = false;
            }
        }
        private void SaveButton_Click_1(object sender, EventArgs e)
        {
            TitanSettings.Instance.Save();
            Logging.Write("Configuration Saved");
            Close();
        }

    }
}
