﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using Styx.Helpers;
using System.IO;
using Styx;

namespace TitanArms
{
    public class TitanSettings : Settings
    {
        public static readonly TitanSettings Instance = new TitanSettings();

        public TitanSettings()
            : base(Path.Combine(Logging.ApplicationPath, string.Format(@"CustomClasses/Config/TitanArms1-Settings-{0}.xml", StyxWoW.Me.Name)))
        {
        }
        [Setting, DefaultValue(4)]
        public int Mobs { get; set; }

        [Setting, DefaultValue(true)]
        public bool DC { get; set; }

        [Setting, DefaultValue(true)]
        public bool RCKLS { get; set; }

        [Setting, DefaultValue(false)]
        public bool CHRG { get; set; }

        [Setting, DefaultValue(true)]
        public bool T1 { get; set; }

        [Setting, DefaultValue(true)]
        public bool T2 { get; set; }

        [Setting, DefaultValue(false)]
        public bool AOE { get; set; }

        [Setting, DefaultValue(true)]
        public bool RS { get; set; }

        [Setting, DefaultValue(false)]
        public bool HL { get; set; }

        [Setting, DefaultValue(true)]
        public bool BS { get; set; }

        [Setting, DefaultValue(true)]
        public bool SS { get; set; }

        [Setting, DefaultValue(true)]
        public bool IR { get; set; }

        [Setting, DefaultValue(true)]
        public bool LB { get; set; }

        [Setting, DefaultValue(false)]
        public bool DSLFR { get; set; }

        [Setting, DefaultValue(false)]
        public bool DSNOR { get; set; }

        [Setting, DefaultValue(false)]
        public bool DSHC { get; set; }

        [Setting, DefaultValue(false)]
        public bool Party { get; set; }
    }
}